<?php
namespace bhl_bind_ecslite;
use Exception;

function supported_tokens()
{
  return [
    'bhl_ecslite_component',
    'bhl_ecslite_component_entity',
  ];
}

class BindEclLitePlugin implements \bhl_bind\BindPlugin
{
  private $units = array();

  function init(\mtgMetaInfo $meta, \Twig\Environment $twig)
  {
    $loader = $twig->getLoader();
    if($loader instanceof \Twig\Loader\FilesystemLoader)
    {
      $loader->setPaths(
        array_merge(
          $loader->getPaths(), 
          [__DIR__ . "/../tpl"]
        )
      );
    }

    //let's collect units we're responsible for
    foreach($meta->getUnits() as $u)
    {
      if($u->object->hasToken('bhl_ecslite_component'))
      {
        $this->units[] = $u;
      }
    }

    //let's remove our units from the original collection
    foreach($this->units as $u)
    {
      $meta->delUnit($u);
    }
  }

  function codegenDecls(\Twig\Environment $twig)
  {
    return '';
  }

  function codegenRegister(\Twig\Environment $twig)
  {
    $code = '';
    foreach($this->units as $u)
    {
      if($u->object->hasToken('bhl_ecslite_component'))
        $code .= $twig->render('bind_ecslite.twig', ['unit' => $u->object]);
    }
    return $code;
  }
}
